/* 
 * $Id: XDTPObjectWrapper.h,v 1.2 2005/10/18 05:04:23 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.2 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___XDTPOBJECTWRAPPER_H
#define ___XDTPOBJECTWRAPPER_H

#include "xdtptypes.h"

namespace XDTP {

extern void objectwrapper_null_destractor(void*);

class XDTPObjectWrapper
{
public:
	XDTPObjectWrapper();
	virtual ~XDTPObjectWrapper();

    /**
     * ˥֥Ȥɲäޤ
     * 
     * @param aType ֥Ȥμ
     * @param aValue ֥
     */
    void add(int aType, const void* aValue);

    /**
     * ֥Ȥޤ
     * 
     * @param aPos  (aPos >= 0)
     * @param aType ֥Ȥμ
     * @param aValue ֥
     */
    void insert(int aPos, int aType, const void* aValue);

    /**
     * ¸Υ֥Ȥ֤ޤ
     * 
     * @param aPos  (aPos >= 0)
     * @param aType ֥Ȥμ
     * @param aValue ֥
     */
    void set(int aPos, int aType, const void* aValue);
    
    /**
     * ֥Ȥޤ
     * 
     * @param aPos  (aPos >= 0)
     * @param aType ֥Ȥμ̤Ǽΰ
     * @return ֥
     */
    void* get(int aPos, int *aType = NULL) const;

    /**
     * ֥Ȥޤ
     * 
     * @param aPos  (aPos >= 0)
     * @param bErase setDestractorˤѤߤκؿȤäƼưŪ
     *               true ꤷޤ
     */
    void erase(int aPos, bool bErase = true);
    
    /**
     * ƤΥ֥Ȥޤ
     * 
     * @param bErase setDestractorˤѤߤκؿȤäƼưŪ
     *               true ꤷޤ
     */
    void clear(bool bErase = true);
    
    /**
     * ϿƤ륪֥Ȥޤ
     */
    int size() const;

public:
    /**
     * ֥ȤκؿϿޤ
     * 
     * @param aType ֥Ȥμ
     * @param destractor ؿؤΥݥ
     */
    static void setDestractor(int aType, void(*destractor)(void*));

private:
    IntVector       m_Types;
    PointerVector   m_Pointers;

private:
    static Int2PointerMap  m_Destractors;
};

};

#endif
