/* 
 * $Id: XDTPModuleLoader.h,v 1.1 2005/10/11 07:35:02 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.1 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___XDTPMODULELOADER_H
#define ___XDTPMODULELOADER_H

#include "glibmm.h"
#include "modules/XDTPModule.h"
#include "modules/XDTPChecker.h"

namespace XDTP {

typedef struct {
    void*   handle;
    XDTPModule* (*buildModule)();
    XDTPChecker* (*buildChecker)();
    void (*freeModule)(XDTPModule*);
    void (*freeChecker)(XDTPChecker*);
    u_int32_t (*getModuleVersion)();
    std::list<XDTPModule*>  module;
    std::list<XDTPChecker*>  checker;
} XDTPModuleLibrary;

class XDTPModuleLoader
{
public:
	virtual ~XDTPModuleLoader();
    
    /**
     * XDTPModule񤹤饤֥ɤޤ
     * 
     * @param aPath XDTPModule񤹤ʥߥå󥯥饤֥ؤΥѥ
     * @return XDTPModule񤹤饤֥ꡣ
     *         פˤʤäʳǡunloadModuleLibraryɬפޤ
     */
    static XDTPModuleLibrary* loadModuleLibrary(const Glib::ustring& aPath);
    
    /**
     * XDTPModule񤹤饤֥ޤ
     * ̤XDTPModule  XDTPChecker¸ߤϡޤ
     * 
     * @param aLibrary XDTPModule񤹤饤֥ꡣ
     */
    static void unloadModuleLibrary(XDTPModuleLibrary* aLibrary);
    
    /**
     * XDTPModuleۤޤ
     * 
     * @param aLibrary XDTPModule񤹤饤֥ꡣ
     * @return XDTPModuleᤷޤפˤʤäʳ freeModule ɬפޤ
     */
    static XDTPModule* buildModule(XDTPModuleLibrary* aLibrary);
    
    /**
     * XDTPCheckerۤޤ
     * 
     * @param aLibrary XDTPChecker񤹤饤֥ꡣ
     * @return XDTPCheckerᤷޤפˤʤäʳ freeChecker ɬפޤ
     */
    static XDTPChecker* buildChecker(XDTPModuleLibrary* aLibrary);

    /**
     * XDTPModuleޤ
     * 
     * @param aLibrary XDTPModule񤹤饤֥ꡣ
     * @param aModule ۤXDTPModule
     */
    static void freeModule(XDTPModuleLibrary* aLibrary, XDTPModule* aModule);
    
    /**
     * XDTPCheckerޤ
     * 
     * @param aLibrary XDTPChecker񤹤饤֥ꡣ
     * @param aModule ۤXDTPChecker
     */
    static void freeChecker(XDTPModuleLibrary* aLibrary, XDTPChecker* aChecker);

private:
    XDTPModuleLoader();
};

};

#endif
